use16
org 0 ; in BIOS: offset 6000 - E000
jmp short start

CHECKSUM db 0

start:
  cli
  cld
  xor ax,ax
  mov ss,ax
  mov sp,0f00h
  mov ax,cs
  mov ds,ax
  mov es,ax
  jmp short install_int21h
  
chrout:
 	cmp al,9
	je chrout_tab
  mov ah,0Eh
  int 10h
  ret
chrout_tab:
  push cx
  mov cx,6
  mov al,' '
chrout_tab_loop:
  call chrout
  loop chrout_tab_loop
  pop cx
  ret
   
install_int21h:
  push ds
  xor ax,ax
  mov ds,ax
  mov word [ds:20h*4],reboot_handler
  mov word [ds:20h*4+2],cs
  mov word [ds:21h*4],int21_handler
  mov word [ds:21h*4+2],cs
  pop ds
  
; binary to load is .COM by default, comment out one or the other
  ;jmp short run_exe
  jmp short run_com
  
run_com:
  push cs
  mov si,reboot_handler
  push si
  mov si,binary_to_load
  mov ax,100h
  mov es,ax
  push es
  mov al,90h
  xor di,di
  push di
  mov cx,100h
  rep stosb
  mov cx,32768d
  rep movsb
  push es
  pop ds
  sti
  retf
   
run_exe:
  mov ax,ds
  mov si,binary_to_load
  add ax,[ds:si+08h]
  mov cx,[ds:si+06h]
  mov bx,[ds:si+18h]
  jcxz relocate_done
  
relocate_loop:
  mov di,[ds:bx]
  mov dx,[ds:bx+2]
  add dx,ax
  push ds
  mov ds,dx
  add [ds:di],ax
  pop ds
  add bx,4
  loop relocate_loop
  
relocate_done:
  mov bx,ax
  add bx,[ds:si+0Eh]
  mov ss,bx
  mov sp,[ds:si+10h]
  add ax,[ds:si+16h]
  push ax
  mov ax,[ds:si+14h]
  push ax
  sti
  retf
   
int21_handler:
  cli
  clc
  cmp ah,0
  je reboot_handler
  cmp ah,1
  je int21_01
  cmp ah,2
  je int21_02
  cmp ah,7
  je int21_07
  cmp ah,8
  je int21_07
  cmp ah,9
  je int21_09
  cmp ah,19h
  je int21_19
  cmp ah,25h
  je int21_25
  cmp ah,30h
  je int21_30
  cmp ah,35h
  je int21_35
  cmp ah,4Ch
  je reboot_handler
  jmp int21_error
int21_01:
  sti
  xor ax,ax
  int 16h
  call chrout
  jmp int21_exit
int21_02:
  push ax
  mov al,dl
  call chrout
  pop ax
  jmp int21_exit
int21_07:
  sti
  xor ax,ax
  int 16h
  jmp int21_exit 
int21_09:
  push bx
  mov bx,dx
int21_09_next:
  mov al,byte[es:bx]
  cmp al,'$'
  je int21_09_done
  call chrout
  inc bx
  jmp int21_09_next
int21_09_done:
  pop bx
  mov al,'$'
  jmp int21_exit
int21_19:
  mov al,0
  jmp int21_exit
int21_25:
  push cx
  mov cl,2
  shl ax,cl
  pop cx
  push si
  push bx
  push es
  mov si,ax
  xor bx,bx
  mov es,bx
  mov word[es:si],dx
  mov bx,ds
  mov word[es:si+2],bx
  pop es
  pop bx
  pop si
  jmp int21_exit
int21_30:
  mov al,3
  mov ah,3
  jmp int21_exit
int21_35:
  push ds
  push si
  xor ah,ah
  push cx
  mov cl,2
  shl ax,cl
  pop cx
  mov si,ax
  xor bx,bx
  mov ds,bx
  mov bx,word[ds:si+2]
  push bx
  mov bx,word[ds:si]
  pop es
  pop si
  pop ds
  jmp int21_exit
int21_error:
  stc
int21_exit:
  sti
  iret
  
binary_to_load:
  times 32756-($-$$) nop

reboot_handler:
  xor ax,ax
  mov ds,ax
  mov [ds:0472h],ax
  jmp far 0ffffh:0h